program fastGPIO;

{$mode objfpc}{$H+}

uses
  SysUtils,
  Classes, armGPIO;

var
  ARM_REG: TMini2440_RegDriver;
  GPIO_Driver: TIoDriver;
  GpF: TIoPort;

begin
  ARM_REG := TMini2440_RegDriver.Create;
  try
  if not ARM_REG.OpenDevMem then
  begin
     WriteLn('Error opening memory file');
     Exit;
  end;

  GPIO_Driver := ARM_REG.CreateIoDriver;

  if not GPIO_Driver.MapIoRegisrty then
  begin
     WriteLn('Error mapping gpio registry');
     Exit;
  end;

  GpF := GpIo_Driver.CreatePort(GPFCON, GPFDAT, GPFUP);
  Gpf.PinConfig[TGpIoPin.Gp0] := TGpIoPinConf.pdOutput;


  while true do
     GpF.InvertBit(Gp0);


  finally
    if Assigned(GpF) then FreeAndNil(GpF);
    if Assigned(GpIo_Driver) then FreeAndNil(GpIo_Driver);
    if Assigned(ARM_REG) then FreeAndNil(ARM_REG);
  end;


end.

